/* afb2r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int afb2r_c(real *a, integer *ma, integer *n, integer *ml,
        integer *mu, integer *nlead, real *rcond, real *z__, integer *ierr)
{
    /* Format strings */
    static char fmt_390[] = "";
    static char fmt_540[] = "";
    static char fmt_590[] = "";
    static char fmt_630[] = "";
    static char fmt_680[] = "";
    static char fmt_720[] = "";
    static char fmt_730[] = "";
    static char fmt_810[] = "";
    static char fmt_530[] = "";
    static char fmt_620[] = "";
    static char fmt_710[] = "";
    static char fmt_800[] = "";

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3, i__4;
    real r__1, r__2, r__3, r__4, r__5, r__6;

    /* Builtin functions */
    double r_sign(real *, real *);

    /* Local variables */
    static integer i__, j, k, l, m;
    static real s, t, x, anorm;
    static integer i0, i1, j0, j1;
    static real ynorm;
    static integer kb;
    static real ek;
    static integer jj, ll, lm, mm, ju;
    static real sm, wk;
    static integer jz;
    extern /* Subroutine */ int utafsi_c(char *, char *, char *, char *, char *
            , integer *, ftnlen, ftnlen, ftnlen, ftnlen, ftnlen);
    static integer kp1, nm1;
    static real wkm;

    /* Assigned format variables */
    static char *ll_fmt;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]

    /* Parameter adjustments */
    a_dim1 = *ma;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    --nlead;
    --z__;

    /* Function Body */
    *rcond = 0.f;
    x = 0.f;
/* L10: */
    if (*n >= 1 && *ma >= 1) {
        goto L20;
    }
    *ierr = 65;
    utafsi_c("A", "F", "B", "2", "R", ierr, 1L, 1L, 1L, 1L, 1L);
    goto L890;
L20:
    *ierr = 0;
    m = *ml + *mu + 1;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* Computing MAX */
        i__2 = 1, i__3 = i__ - *ml;
        j0 = max(i__2,i__3);
/* Computing MIN */
        i__2 = *n, i__3 = i__ + *mu;
        j1 = min(i__2,i__3);
        i__2 = j1;
        for (j = j0; j <= i__2; ++j) {
            k = j - i__ + *ml + 1;
            z__[j] = a_ref(i__, k);
/* L30: */
        }
        i__2 = j1;
        for (j = j0; j <= i__2; ++j) {
            a_ref(i__, j) = z__[j];
/* L40: */
        }
/* L50: */
    }
    anorm = 0.f;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* Computing MAX */
        i__2 = 1, i__3 = j - *mu;
        i0 = max(i__2,i__3);
/* Computing MIN */
        i__2 = *n, i__3 = j + *ml;
        i1 = min(i__2,i__3);
        i__2 = i1;
        for (i__ = i0; i__ <= i__2; ++i__) {
            k = i__ - j + m;
            z__[k] = a_ref(i__, j);
/* L60: */
        }
        s = 0.f;
        i__2 = i1;
        for (i__ = i0; i__ <= i__2; ++i__) {
            k = i__ - j + m;
            a_ref(k, j) = z__[k];
            s += (r__1 = z__[k], abs(r__1));
/* L70: */
        }
        if (s > anorm) {
            anorm = s;
        }
/* L80: */
    }
    j0 = *mu + 2;
    j1 = min(*n,m) - 1;
    if (j1 < j0) {
        goto L110;
    }
    i__1 = j1;
    for (jz = j0; jz <= i__1; ++jz) {
        i0 = m + 1 - jz;
        i__2 = *ml;
        for (i__ = i0; i__ <= i__2; ++i__) {
            a_ref(i__, jz) = 0.f;
/* L90: */
        }
/* L100: */
    }
L110:
    jz = j1;
    ju = 0;
    nm1 = *n - 1;
    if (nm1 < 1) {
        goto L310;
    }
    i__1 = nm1;
    for (k = 1; k <= i__1; ++k) {
        kp1 = k + 1;
        ++jz;
        if (jz > *n) {
            goto L130;
        }
        if (*ml < 1) {
            goto L130;
        }
        i__2 = *ml;
        for (i__ = 1; i__ <= i__2; ++i__) {
            a_ref(i__, jz) = 0.f;
/* L120: */
        }
L130:
/* Computing MIN */
        i__2 = *ml, i__3 = *n - k;
        lm = min(i__2,i__3);
        l = m;
        s = (r__1 = a_ref(m, k), abs(r__1));
        i0 = m + 1;
        i1 = m + lm;
        i__2 = i1;
        for (i__ = i0; i__ <= i__2; ++i__) {
            if ((r__1 = a_ref(i__, k), abs(r__1)) <= s) {
                goto L140;
            }
            l = i__;
            s = (r__1 = a_ref(i__, k), abs(r__1));
L140:
/* L150: */
            ;
        }
        nlead[k] = l + k - m;
        if (a_ref(l, k) == 0.f) {
            goto L280;
        }
        if (l == m) {
            goto L160;
        }
        t = a_ref(l, k);
        a_ref(l, k) = a_ref(m, k);
        a_ref(m, k) = t;
L160:
        t = -1.f / a_ref(m, k);
        i0 = m + 1;
        i1 = m + lm;
        i__ = lm % 5 + m;
        if (i__ == m) {
            goto L180;
        }
        i__2 = i__;
        for (j = i0; j <= i__2; ++j) {
            a_ref(j, k) = t * a_ref(j, k);
/* L170: */
        }
L180:
        ++i__;
        if (i__ > i1) {
            goto L200;
        }
        i__2 = i1;
        for (j = i__; j <= i__2; j += 5) {
            a_ref(j, k) = t * a_ref(j, k);
            a_ref(j + 1, k) = t * a_ref(j + 1, k);
            a_ref(j + 2, k) = t * a_ref(j + 2, k);
            a_ref(j + 3, k) = t * a_ref(j + 3, k);
            a_ref(j + 4, k) = t * a_ref(j + 4, k);
/* L190: */
        }
L200:
/* Computing MIN */
/* Computing MAX */
        i__3 = ju, i__4 = *mu + nlead[k];
        i__2 = max(i__3,i__4);
        ju = min(i__2,*n);
        mm = m;
        if (ju < kp1) {
            goto L270;
        }
        i__2 = ju;
        for (j = kp1; j <= i__2; ++j) {
            --l;
            --mm;
            t = a_ref(l, j);
            if (l == mm) {
                goto L210;
            }
            a_ref(l, j) = a_ref(mm, j);
            a_ref(mm, j) = t;
L210:
            i0 = m + 1;
            i1 = m + lm;
            i__ = lm % 4 + m;
            if (i__ == m) {
                goto L230;
            }
            i__3 = i__;
            for (jj = i0; jj <= i__3; ++jj) {
                kb = jj + mm - m;
                a_ref(kb, j) = a_ref(kb, j) + t * a_ref(jj, k);
/* L220: */
            }
L230:
            ++i__;
            if (i__ > i1) {
                goto L250;
            }
            i__3 = i1;
            for (jj = i__; jj <= i__3; jj += 4) {
                kb = jj + mm - m;
                a_ref(kb, j) = a_ref(kb, j) + t * a_ref(jj, k);
                a_ref(kb + 1, j) = a_ref(kb + 1, j) + t * a_ref(jj + 1, k);
                a_ref(kb + 2, j) = a_ref(kb + 2, j) + t * a_ref(jj + 2, k);
                a_ref(kb + 3, j) = a_ref(kb + 3, j) + t * a_ref(jj + 3, k);
/* L240: */
            }
L250:
/* L260: */
            ;
        }
L270:
        goto L290;
L280:
        *ierr = -k;
L290:
/* L300: */
        ;
    }
L310:
    if (a_ref(m, *n) == 0.f) {
        *ierr = -(*n);
    }
    nlead[*n] = *n;
    if (*ierr == 0) {
        goto L320;
    }
    utafsi_c("A", "F", "B", "2", "R", ierr, 1L, 1L, 1L, 1L, 1L);
    goto L820;
L320:
    ek = 1.f;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        z__[j] = 0.f;
/* L330: */
    }
    ju = 0;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        if (z__[k] != 0.f) {
            r__1 = -z__[k];
            ek = (real)r_sign(&ek, &r__1);
        }
        if ((r__1 = ek - z__[k], abs(r__1)) <= (r__2 = a_ref(m, k), abs(r__2))
                ) {
            goto L400;
        }
        s = (r__1 = a_ref(m, k), abs(r__1)) / (r__2 = ek - z__[k], abs(r__2));
        ll = 0;
        ll_fmt = fmt_390;
L340:
        i__ = *n % 5;
        if (i__ == 0) {
            goto L360;
        }
        i__2 = i__;
        for (jj = 1; jj <= i__2; ++jj) {
            z__[jj] = s * z__[jj];
/* L350: */
        }
        if (*n < 5) {
            goto L380;
        }
L360:
        ++i__;
        i__2 = *n;
        for (jj = i__; jj <= i__2; jj += 5) {
            z__[jj] = s * z__[jj];
            z__[jj + 1] = s * z__[jj + 1];
            z__[jj + 2] = s * z__[jj + 2];
            z__[jj + 3] = s * z__[jj + 3];
            z__[jj + 4] = s * z__[jj + 4];
/* L370: */
        }
L380:
        switch (ll) {
            case 0: goto L390;
            case 1: goto L530;
            case 2: goto L540;
            case 3: goto L590;
            case 4: goto L620;
            case 5: goto L630;
            case 6: goto L680;
            case 7: goto L710;
            case 8: goto L720;
            case 9: goto L730;
            case 10: goto L800;
            case 11: goto L810;
        }
L390:
        ek = s * ek;
L400:
        wk = ek - z__[k];
        wkm = -ek - z__[k];
        s = abs(wk);
        sm = abs(wkm);
        if (a_ref(m, k) == 0.f) {
            goto L410;
        }
        wk /= a_ref(m, k);
        wkm /= a_ref(m, k);
        goto L420;
L410:
        wk = 1.f;
        wkm = 1.f;
L420:
        kp1 = k + 1;
/* Computing MIN */
/* Computing MAX */
        i__3 = ju, i__4 = *mu + nlead[k];
        i__2 = max(i__3,i__4);
        ju = min(i__2,*n);
        mm = m;
        if (kp1 > ju) {
            goto L460;
        }
        i__2 = ju;
        for (j = kp1; j <= i__2; ++j) {
            --mm;
            sm += (r__1 = z__[j] + wkm * a_ref(mm, j), abs(r__1));
            z__[j] += wk * a_ref(mm, j);
            s += (r__1 = z__[j], abs(r__1));
/* L430: */
        }
        if (s >= sm) {
            goto L450;
        }
        t = wkm - wk;
        wk = wkm;
        mm = m;
        i__2 = ju;
        for (j = kp1; j <= i__2; ++j) {
            --mm;
            z__[j] += t * a_ref(mm, j);
/* L440: */
        }
L450:
L460:
        z__[k] = wk;
/* L470: */
    }
    ll = 1;
    ll_fmt = fmt_530;
L480:
    s = 0.f;
    i__ = *n % 6;
    if (i__ == 0) {
        goto L500;
    }
    i__1 = i__;
    for (jj = 1; jj <= i__1; ++jj) {
        s += (r__1 = z__[jj], abs(r__1));
/* L490: */
    }
    if (*n < 6) {
        goto L520;
    }
L500:
    ++i__;
    i__1 = *n;
    for (jj = i__; jj <= i__1; jj += 6) {
        s = s + (r__1 = z__[jj], abs(r__1)) + (r__2 = z__[jj + 1], abs(r__2)) 
                + (r__3 = z__[jj + 2], abs(r__3)) + (r__4 = z__[jj + 3], abs(
                r__4)) + (r__5 = z__[jj + 4], abs(r__5)) + (r__6 = z__[jj + 5]
                , abs(r__6));
/* L510: */
    }
L520:
    s = 1.f / s;
    switch (ll) {
        case 0: goto L390;
        case 1: goto L530;
        case 2: goto L540;
        case 3: goto L590;
        case 4: goto L620;
        case 5: goto L630;
        case 6: goto L680;
        case 7: goto L710;
        case 8: goto L720;
        case 9: goto L730;
        case 10: goto L800;
        case 11: goto L810;
    }
L530:
    ll = 2;
    ll_fmt = fmt_540;
    goto L340;
L540:
    i__1 = *n;
    for (kb = 1; kb <= i__1; ++kb) {
        k = *n + 1 - kb;
/* Computing MIN */
        i__2 = *ml, i__3 = *n - k;
        lm = min(i__2,i__3);
        if (k >= *n) {
            goto L580;
        }
        i0 = m + 1;
        i1 = m + lm;
        i__ = lm % 5 + m;
        if (i__ == m) {
            goto L560;
        }
        i__2 = i__;
        for (jj = i0; jj <= i__2; ++jj) {
            kp1 = jj + k - m;
            z__[k] += a_ref(jj, k) * z__[kp1];
/* L550: */
        }
L560:
        ++i__;
        if (i__ > i1) {
            goto L580;
        }
        i__2 = i1;
        for (jj = i__; jj <= i__2; jj += 5) {
            kp1 = jj + k - m;
            z__[k] = z__[k] + a_ref(jj, k) * z__[kp1] + a_ref(jj + 1, k) * 
                    z__[kp1 + 1] + a_ref(jj + 2, k) * z__[kp1 + 2] + a_ref(jj 
                    + 3, k) * z__[kp1 + 3] + a_ref(jj + 4, k) * z__[kp1 + 4];
/* L570: */
        }
L580:
        if ((r__1 = z__[k], abs(r__1)) <= 1.f) {
            goto L600;
        }
        s = 1.f / (r__1 = z__[k], abs(r__1));
        ll = 3;
        ll_fmt = fmt_590;
        goto L340;
L590:
L600:
        l = nlead[k];
        t = z__[l];
        z__[l] = z__[k];
        z__[k] = t;
/* L610: */
    }
    ll = 4;
    ll_fmt = fmt_620;
    goto L480;
L620:
    ll = 5;
    ll_fmt = fmt_630;
    goto L340;
L630:
    ynorm = 1.f;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        l = nlead[k];
        t = z__[l];
        z__[l] = z__[k];
        z__[k] = t;
/* Computing MIN */
        i__2 = *ml, i__3 = *n - k;
        lm = min(i__2,i__3);
        if (k >= *n) {
            goto L670;
        }
        i0 = m + 1;
        i1 = m + lm;
        i__ = lm % 4 + m;
        if (i__ == m) {
            goto L650;
        }
        i__2 = i__;
        for (jj = i0; jj <= i__2; ++jj) {
            kp1 = jj + k - m;
            z__[kp1] += t * a_ref(jj, k);
/* L640: */
        }
L650:
        ++i__;
        if (i__ > i1) {
            goto L670;
        }
        i__2 = i1;
        for (jj = i__; jj <= i__2; jj += 4) {
            kp1 = jj + k - m;
            z__[kp1] += t * a_ref(jj, k);
            z__[kp1 + 1] += t * a_ref(jj + 1, k);
            z__[kp1 + 2] += t * a_ref(jj + 2, k);
            z__[kp1 + 3] += t * a_ref(jj + 3, k);
/* L660: */
        }
L670:
        if ((r__1 = z__[k], abs(r__1)) <= 1.f) {
            goto L690;
        }
        s = 1.f / (r__1 = z__[k], abs(r__1));
        ll = 6;
        ll_fmt = fmt_680;
        goto L340;
L680:
        ynorm = s * ynorm;
L690:
/* L700: */
        ;
    }
    ll = 7;
    ll_fmt = fmt_710;
    goto L480;
L710:
    ll = 8;
    ll_fmt = fmt_720;
    goto L340;
L720:
    ynorm = s * ynorm;
    i__1 = *n;
    for (kb = 1; kb <= i__1; ++kb) {
        k = *n + 1 - kb;
        if ((r__1 = z__[k], abs(r__1)) <= (r__2 = a_ref(m, k), abs(r__2))) {
            goto L740;
        }
        s = (r__1 = a_ref(m, k), abs(r__1)) / (r__2 = z__[k], abs(r__2));
        ll = 9;
        ll_fmt = fmt_730;
        goto L340;
L730:
        ynorm = s * ynorm;
L740:
        if (a_ref(m, k) != 0.f) {
            z__[k] /= a_ref(m, k);
        }
        if (a_ref(m, k) == 0.f) {
            z__[k] = 1.f;
        }
        t = -z__[k];
        lm = min(k,m) - 1;
        if (lm < 1) {
            goto L780;
        }
        i0 = m - lm;
        i1 = m - 1;
        i__ = lm % 4 + i0 - 1;
        if (i__ < i0) {
            goto L760;
        }
        i__2 = i__;
        for (jj = i0; jj <= i__2; ++jj) {
            kp1 = jj + k - m;
            z__[kp1] += t * a_ref(jj, k);
/* L750: */
        }
L760:
        ++i__;
        if (i__ > i1) {
            goto L780;
        }
        i__2 = i1;
        for (jj = i__; jj <= i__2; jj += 4) {
            kp1 = jj + k - m;
            z__[kp1] += t * a_ref(jj, k);
            z__[kp1 + 1] += t * a_ref(jj + 1, k);
            z__[kp1 + 2] += t * a_ref(jj + 2, k);
            z__[kp1 + 3] += t * a_ref(jj + 3, k);
/* L770: */
        }
L780:
/* L790: */
        ;
    }
    ll = 10;
    ll_fmt = fmt_800;
    goto L480;
L800:
    ll = 11;
    ll_fmt = fmt_810;
    goto L340;
L810:
    ynorm = s * ynorm;
    if (anorm != 0.f) {
        *rcond = ynorm / anorm;
    }
L820:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* Computing MAX */
        i__2 = 1, i__3 = j - *mu - *ml;
        i0 = max(i__2,i__3);
/* Computing MIN */
        i__2 = *n, i__3 = j + *ml;
        i1 = min(i__2,i__3);
        i__2 = i1;
        for (i__ = i0; i__ <= i__2; ++i__) {
            k = i__ - j + m;
            z__[i__] = a_ref(k, j);
            a_ref(k, j) = 0.f;
/* L830: */
        }
        i__2 = i1;
        for (i__ = i0; i__ <= i__2; ++i__) {
            a_ref(i__, j) = z__[i__];
/* L840: */
        }
/* L850: */
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* Computing MAX */
        i__2 = 1, i__3 = i__ - *ml;
        j0 = max(i__2,i__3);
/* Computing MIN */
        i__2 = *n, i__3 = i__ + *mu + *ml;
        j1 = min(i__2,i__3);
        i__2 = j1;
        for (j = j0; j <= i__2; ++j) {
            k = j - i__ + *ml + 1;
            z__[k] = a_ref(i__, j);
            a_ref(i__, j) = 0.f;
/* L860: */
        }
        i__2 = j1;
        for (j = j0; j <= i__2; ++j) {
            k = j - i__ + *ml + 1;
            a_ref(i__, k) = z__[k];
/* L870: */
        }
/* L880: */
    }
L890:
    return 0;
} /* afb2r_c */

#undef a_ref
